// Objet statique/singleton
var monstre1 = {
	x:10,
	y:10,
	draw: function() {
		console.log("x = " + this.x);
	}
}

// 1ère methode : avec des pseudo
// classes appelées "fonctions constructeur"
// ES5 (JavaScript "classique")

function Ball(x, y, couleur) {
	this.x = x;
	this.y = y;
	this.couleur = couleur;

	this.draw = function() {
		console.log("x = " + this.x + 
			" y = " + this.y);
	}
}

// Pseudo classes ES2015/ES2016
class BallNew {
	constructor(x, y, couleur) {
		this.x = x;
		this.y = y;
		this.couleur = couleur;
	}

	draw() {
		console.log("x = " + this.x);
	}
}

// Black box model
// voir aussi "héritage fonctionnel"
function BallBB(x, y, color) {
	var xb = x;
	var yb =y;
	var yc = color;

	var draw = function () {
		console.log("x = " + xb);
	}

	// API de mon objet
	var api = {
		draw: draw
	}

	return api;
}